import Vue from 'vue'
import Router from 'vue-router'
import { normalizeURL, decode } from 'ufo'
import { interopDefault } from './utils'
import scrollBehavior from './router.scrollBehavior.js'

const _eab146ec = () => interopDefault(import('../pages/about.vue' /* webpackChunkName: "pages/about" */))
const _5340ab2c = () => interopDefault(import('../pages/Admin.vue' /* webpackChunkName: "pages/Admin" */))
const _4524e846 = () => interopDefault(import('../pages/Authorize.vue' /* webpackChunkName: "pages/Authorize" */))
const _f7d157f2 = () => interopDefault(import('../pages/export.vue' /* webpackChunkName: "pages/export" */))
const _290e0b74 = () => interopDefault(import('../pages/Login.vue' /* webpackChunkName: "pages/Login" */))
const _1cc49e54 = () => interopDefault(import('../pages/Register.vue' /* webpackChunkName: "pages/Register" */))
const _4d468bfb = () => interopDefault(import('../pages/search.vue' /* webpackChunkName: "pages/search" */))
const _6d762a36 = () => interopDefault(import('../pages/settings.vue' /* webpackChunkName: "pages/settings" */))
const _2f6a6632 = () => interopDefault(import('../pages/embed/list.vue' /* webpackChunkName: "pages/embed/list" */))
const _30afff78 = () => interopDefault(import('../pages/add/_edit.vue' /* webpackChunkName: "pages/add/_edit" */))
const _4b446485 = () => interopDefault(import('../pages/announcement/_id.vue' /* webpackChunkName: "pages/announcement/_id" */))
const _3874709f = () => interopDefault(import('../pages/collection/_collection.vue' /* webpackChunkName: "pages/collection/_collection" */))
const _51b24b46 = () => interopDefault(import('../pages/embed/_event_id.vue' /* webpackChunkName: "pages/embed/_event_id" */))
const _eaa855dc = () => interopDefault(import('../pages/event/_slug.vue' /* webpackChunkName: "pages/event/_slug" */))
const _476dcfba = () => interopDefault(import('../pages/place/_place.vue' /* webpackChunkName: "pages/place/_place" */))
const _a3dc8f44 = () => interopDefault(import('../pages/recover/_code.vue' /* webpackChunkName: "pages/recover/_code" */))
const _1601dbf0 = () => interopDefault(import('../pages/setup/_db.vue' /* webpackChunkName: "pages/setup/_db" */))
const _31c8607a = () => interopDefault(import('../pages/tag/_tag.vue' /* webpackChunkName: "pages/tag/_tag" */))
const _873122c8 = () => interopDefault(import('../pages/user_confirm/_code.vue' /* webpackChunkName: "pages/user_confirm/_code" */))
const _ab419162 = () => interopDefault(import('../pages/index.vue' /* webpackChunkName: "pages/index" */))

const emptyFn = () => {}

Vue.use(Router)

export const routerOptions = {
  mode: 'history',
  base: '/',
  linkActiveClass: 'nuxt-link-active',
  linkExactActiveClass: 'nuxt-link-exact-active',
  scrollBehavior,

  routes: [{
    path: "/about",
    component: _eab146ec,
    name: "about"
  }, {
    path: "/Admin",
    component: _5340ab2c,
    name: "Admin"
  }, {
    path: "/Authorize",
    component: _4524e846,
    name: "Authorize"
  }, {
    path: "/export",
    component: _f7d157f2,
    name: "export"
  }, {
    path: "/Login",
    component: _290e0b74,
    name: "Login"
  }, {
    path: "/Register",
    component: _1cc49e54,
    name: "Register"
  }, {
    path: "/search",
    component: _4d468bfb,
    name: "search"
  }, {
    path: "/settings",
    component: _6d762a36,
    name: "settings"
  }, {
    path: "/embed/list",
    component: _2f6a6632,
    name: "embed-list"
  }, {
    path: "/add/:edit?",
    component: _30afff78,
    name: "add-edit"
  }, {
    path: "/announcement/:id?",
    component: _4b446485,
    name: "announcement-id"
  }, {
    path: "/collection/:collection?",
    component: _3874709f,
    name: "collection-collection"
  }, {
    path: "/embed/:event_id?",
    component: _51b24b46,
    name: "embed-event_id"
  }, {
    path: "/event/:slug?",
    component: _eaa855dc,
    name: "event-slug"
  }, {
    path: "/place/:place?",
    component: _476dcfba,
    name: "place-place"
  }, {
    path: "/recover/:code?",
    component: _a3dc8f44,
    name: "recover-code"
  }, {
    path: "/setup/:db?",
    component: _1601dbf0,
    name: "setup-db"
  }, {
    path: "/tag/:tag?",
    component: _31c8607a,
    name: "tag-tag"
  }, {
    path: "/user_confirm/:code?",
    component: _873122c8,
    name: "user_confirm-code"
  }, {
    path: "/",
    component: _ab419162,
    name: "index"
  }],

  fallback: false
}

export function createRouter (ssrContext, config) {
  const base = (config._app && config._app.basePath) || routerOptions.base
  const router = new Router({ ...routerOptions, base  })

  // TODO: remove in Nuxt 3
  const originalPush = router.push
  router.push = function push (location, onComplete = emptyFn, onAbort) {
    return originalPush.call(this, location, onComplete, onAbort)
  }

  const resolve = router.resolve.bind(router)
  router.resolve = (to, current, append) => {
    if (typeof to === 'string') {
      to = normalizeURL(to)
    }
    return resolve(to, current, append)
  }

  return router
}
